//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsshutdown.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"

// SHUTDOWN FILE SYSTEM

int FSShutdown()
{
SD_CARD temp,*card=NULL;
FS_VOLUME *fs;
FS_FILE *file;
int i,j;

if(!FSystem.Init) return TRUE;

// CLOSE OPEN FILES AND UNMOUNT VOLUMES
// AND FREE ALL ALLOCATED TEMPORARY MEMORY
for(i=0;i<4;++i)
{
fs=FSystem.Volumes[i];
if(fs!=NULL) {
for(j=0;j<FS_MAXOPENFILES;++j)
{
if(fs->Files[j]!=NULL) {
//printf("closing files %d\n",j);
FSClose(fs->Files[j]);
}
}

// DELETE CURRENTDIR IF ANY
//printf("Freeing current Dir\n");
if(fs->CurrentDir!=&(fs->RootDir)) {
file=fs->CurrentDir;
fs->CurrentDir=&fs->RootDir;
while(file) file=FSFreeFile(file);
}
// FREE CLUSTER IN ROOTDIR WHEN FAT32
FSFreeChain(&fs->RootDir);
FSystem.Volumes[i]=NULL;
//printf("done\n");
card=fs->Disk;
free(fs);
}
}
if(card) free(card);

// CLOSE SD DEVICE
SDPowerDown();
SDIOSetup(&temp,TRUE);

FSystem.Init=0;

return TRUE;
}


