//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// Simple Stream Library for HP49g+

#include <string.h>
#include <stdio.h>
#include <fsystem.h>


SIZE_T fwrite(const void *buf, SIZE_T size, SIZE_T cnt, FILE *f)
{
    int written;
    char *ptr=(char *)buf;
    int ret;
    if(f->writecache==NULL) {
    	// IF NO CACHING WAS ACTIVE, THEN SIMPLY WRITE
        written = FSWrite(ptr,  (size * cnt),f->file);
        return (SIZE_T) written/size;
    }
    // IF CACHING WAS ACTIVE, USE IT
    written=size*cnt;
    if(f->cacheused+written >= 512) {
    	if(f->cacheused!=0) {
    	// PACK DATA
    	memcpy(f->writecache+f->cacheused,ptr,512-f->cacheused);
    	ret=FSWrite(f->writecache,512,f->file);
    	if(ret!=512) return (ret>f->cacheused)? ((ret-f->cacheused)/size):0;
    	written-=ret-f->cacheused;
    	f->cacheused=0;
    	ptr+=ret-f->cacheused;
    	}
    	// NO DATA IN CACHE, JUST WRITE FULL SECTORS
    	ret=FSWrite(ptr,written&~511,f->file);
    	if(ret!=(written&(~511))) return ret/size;
    	ptr+=written&(~511);
    	written&=511;
    }


    	memcpy(f->writecache+f->cacheused,buf,written);
    	f->cacheused+=written;

    	return cnt;
}





