//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <stdlib.h>
#include <math.h>
#include <master_globals.h>

// ROMLIB CHECKED
// < ibl ; 2006-04-03 >

// $Id: gauss.c 514 2007-11-18 03:11:26Z ingo $
        
double
gauss()
{
    
    double s,v1,v2,mult;
    
    if (__mg->__gauss_have_next_gaussian) {
        __mg->__gauss_have_next_gaussian = 0;
        return __mg->__gauss_next_gaussian;
    }
    
    s = 0.0;
    do {
        v1 = 2.0 * random() - 1.0;
        v2 = 2.0 * random() - 1.0;
        s  = v1*v1 + v2*v2;
    } while ( s >= 1.0 );
    mult = sqrt(-2.0 * log(s)/s);
    __mg->__gauss_next_gaussian = mult * v2;
    __mg->__gauss_have_next_gaussian = 1;
    
    return mult * v1;
}

double
normal(double mu, double sigma)
{
    return gauss()*sigma + mu;
}


