//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_list.c 486 2007-10-21 21:17:04Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>

extern int __sat3_getblockinfo(SAT_OBJECT ptr,SAT_OBJECT *blkstart,int *blksize);

SAT_OBJECT sat3_createlist(SAT_OBJECT where,int allocsize )
{

    where=sat3_alloc(where,10+allocsize);
	if(where==0) return 0;
	
	sat3_poke(where,SAT_DOLIST,5);
    sat3_poke(where+5,SAT_SEMI,5);

    return where;
}

SAT_OBJECT sat3_listhead(SAT_OBJECT list)
{
if(!list) return 0;
if(sat3_peek(list,5)==SAT_DOLIST)  return list+5;
return 0;
}



SAT_OBJECT sat3_listnext(SAT_OBJECT obj)
{
if(!obj) return 0;
if(sat3_peek(obj,5)==SAT_SEMI) return 0;
return sat3_skipob(obj);
}



// low-level find tail from anywhere within list
SAT_OBJECT __sat3_listtail(SAT_OBJECT list)
{
while(list && (sat3_peek(list,5)!=SAT_SEMI))  list=sat3_skipob(list);
return list;
}

// user API find tail given list object
SAT_OBJECT sat3_listtail(SAT_OBJECT list)
{
return __sat3_listtail(sat3_listhead(list));
}

SAT_OBJECT sat3_listget(SAT_OBJECT list, int position)
{
list=sat3_listhead(list);

if(position<0) return 0;

while((position--) && list) {
list=sat3_listnext(list);
}
return list;

}


BOOL sat3_listclose(SAT_OBJECT position)
{
position=sat3_alloc(position,5);

if(position) {  sat3_poke(position,SAT_SEMI,5); return TRUE; }

return FALSE;
}


BOOL sat3_listinsert(SAT_OBJECT position,SAT_OBJECT object)
{
SAT_OBJECT blk;
int blksize;

if(__sat3_getblockinfo(position,&blk,&blksize)==INVALID_PTR) return 0;	// DO NOT WRITE

int size=sat3_sizeof(object);
SAT_OBJECT listend=sat3_skipob(blk);

if(sat3_alloc(position,listend-position+size)) {
sat3_memmove(position+size,position,listend-position);
// ADJUST OBJECT POINTER IF IT LIES WITHIN THE RECENTLY MOVED MEMORY BLOCK
if(object>=position && object<=listend) object+=size;
sat3_memmove(position,object,size);
return TRUE;
}

return FALSE;
}

BOOL sat3_listremove(SAT_OBJECT position)
{
SAT_OBJECT blk;
int blksize;

if(__sat3_getblockinfo(position,&blk,&blksize)==INVALID_PTR) return 0;	// DO NOT WRITE

int size=sat3_sizeof(position);
SAT_OBJECT listend=sat3_skipob(blk);

if(__sat3_listtail(position)==position) return FALSE;  // FAIL IF TRYING TO REMOVE AT END OF LIST 

sat3_memmove(position,position+size,listend-position-size);
return TRUE;
}

BOOL sat3_listappend(SAT_OBJECT list,SAT_OBJECT object)
{
return sat3_listinsert(sat3_listtail(list),object);
}

int sat3_listcount(SAT_OBJECT list)
{
SAT_OBJECT head=sat3_listhead(list);

if(!head) return -1;

int count=0;
while( (head=sat3_listnext(head))) ++count;
return count;
}

