//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_tag.c 547 2008-02-06 01:01:02Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>


SAT_OBJECT sat3_createtag_str(SAT_OBJECT where,char *tag,SAT_OBJECT obj)
{
	if(!tag) return 0;
	if(!obj) return 0;
int len=strlen(tag);
int objsize=sat3_sizeof(obj);
    where=sat3_alloc(where,12+2*len+objsize);
	if(where==0) return 0;
	
	sat3_poke(where,SAT_DOTAG,5);
    sat3_poke(where+5,len,2);
	int addr=where+7;
	
	while(len--) { sat3_poke(addr,*tag++,2); addr+=2; }
	sat3_memmove(addr,obj,objsize);
	sat3_poke(addr+objsize,SAT_SEMI,5);
	
    return where;
}

extern BOOL __sat3_convertid_str(SAT_OBJECT cstr,char *string, int maxchars);

BOOL sat3_converttag_str(SAT_OBJECT cstr,char *string, int maxchars)
{
	if(!cstr) return 0;
	if(sat3_isptr(cstr)) cstr=sat3_peek(cstr,5);

if(sat3_peek(cstr,5)!=SAT_DOTAG) return 0;	// RETURN 0 IF NOT A TAG

return __sat3_convertid_str(cstr,string,maxchars);

}


// RETURN OBJECT WITHOUT THE TAG

SAT_OBJECT sat3_striptag(SAT_OBJECT obj)
{
	if(!obj) return 0;
	if(sat3_isptr(obj)) obj=sat3_peek(obj,5);

if(sat3_peek(obj,5)!=SAT_DOTAG) return obj;		// NOT A TAGGED OBJECT, NOTHING TO STRIP

return obj+2+sat3_peek(obj+5,2)*2;	
	
}


