//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <hpgcc3.h>
// ROMLIB CHECKED
#include <master_globals.h>



// atexit machinery added by ibl 2005-01-31


// semaphore added by ibl 2005-02-04

// open file list handling ibl 2005-02-06


int _exit_save(unsigned int *ptr);

void __exit(unsigned int *ptr);


void __exit_cleanup()
{
    

// COMPLETELY REWRITTEN BY CLAUDIO - JAN 2005

    
    // atexit handling added: < ibl ; 2005-01-31 >
    
    ATEXIT_ENTRY *q,*p = __mg->__at_exit_vector;
    
    // ensure exactly one entry    and signal exit() in progress
    
    if (__mg->_exit_lock++) return;

    while ((q=p)) {
        (*(p->f))();
        p = p->next;
        // free()'ing the memory is actually superfluous, since we are exit()'ing ...
        free(q);
        // ... but let's keep up the good style anyway 
    }
    
    // close all open files ...
    // NO LONGER NEEDED WHEN USING FSYSTEM SINCE FSShutdown DOES IT.
    /*
    OPEN_LIST_ENTRY *g,*f = __mg->__open_file_list;
    
    while((g=f)) {
        fclose(f->file);
        f = f->next;
        free(g);
    }
    */

    // ADD MORE CLEANUP HERE

}

void exit(int code)
{
    __exit_cleanup();

    // RETURN TO _start
    __exit(__mg->__exit_stk_state);
    
    while(1);
}


#define __SAT_WARMSTART 0x267e5

void __exit_warm(void)
{
	// PANIC FUNCTION TO EXIT TO SATURN DOING A WARMSTART
    unsigned int volatile * INTMSK = (unsigned int*) 0x7100008;   
	*INTMSK = 0xffffffff; //mask all interrupts

	unsigned int *org_regs=(unsigned int *)(__mg->__exit_stk_state[14]);	// GET ADDRESS OF ORIGINAL REGISTERS
	
	org_regs[0]=__SAT_WARMSTART;		// INSTRUCT TO WARMSTART AFTER RETURNING TO SATURN
	
    __exit_cleanup();

    // RETURN TO _start
    __exit(__mg->__exit_stk_state);
}

/*
extern void __go_supervisor(unsigned int __funcaddr,unsigned int SWI_vector);

static void __do_reset(void) __attribute__ ((naked));
static void __do_reset(void)
{
asm volatile ("mrs r0,cpsr");
asm volatile ("orr r0,r0,#0xc0");
asm volatile ("msr cpsr,r0");
asm volatile ("mov pc,#0");
}
*/

void __exception_uninst(unsigned int *org_handler);

void __exit_reset(void)
{
	// PANIC FUNCTION TO EXIT THE PROGRAM BY CAUSING A TOTAL RESET
	
    unsigned int volatile * INTMSK = (unsigned int*) 0x7100008;   
	*INTMSK = 0xffffffff; //mask all interrupts

	unsigned int *org_handlers=(unsigned int *)(__mg->__exit_stk_state[15]);	// GET ADDRESS OF ORIGINAL REGISTERS
	
    __exit_cleanup();

	__exception_uninst(org_handlers);
	
	kos_Reset();
	//__go_supervisor( (unsigned int) &__do_reset, 0x08000008);
}
